## Export data by query

### cURL

```bash
curl --request POST \
  --url https://api.fabric.inc/v3/oms-exports \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-channel-id: <x-fabric-channel-id>' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "filters": {
    "createdAt": "2022-08-01T20:03:28Z"
  },
  "module": "ORDER",
  "recordFormat": "CSV",
  "csvHeadersConfig": "default",
  "sort": "+updatedAt, +createdAt"
}'
```

### Python

```python
import requests

url = "https://api.fabric.inc/v3/oms-exports"

payload = {
    "filters": { "createdAt": "2022-08-01T20:03:28Z" },
    "module": "ORDER",
    "recordFormat": "CSV",
    "csvHeadersConfig": "default",
    "sort": "+updatedAt, +createdAt"
}
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "x-fabric-channel-id": "<x-fabric-channel-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript (Fetch)

```javascript
const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    'x-fabric-channel-id': '<x-fabric-channel-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    filters: {createdAt: '2022-08-01T20:03:28Z'},
    module: 'ORDER',
    recordFormat: 'CSV',
    csvHeadersConfig: 'default',
    sort: '+updatedAt, +createdAt'
  })
};

fetch('https://api.fabric.inc/v3/oms-exports', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```php
$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/oms-exports",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'filters' => [
        'createdAt' => '2022-08-01T20:03:28Z'
    ],
    'module' => 'ORDER',
    'recordFormat' => 'CSV',
    'csvHeadersConfig' => 'default',
    'sort' => '+updatedAt, +createdAt'
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-channel-id: <x-fabric-channel-id>",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

### Go

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://api.fabric.inc/v3/oms-exports"

payload := strings.NewReader("{\n  \"filters\": {\n    \"createdAt\": \"2022-08-01T20:03:28Z\"}\n  ,\"module\": \"ORDER\",\n  \"recordFormat\": \"CSV\",\n  \"csvHeadersConfig\": \"default\",\n  \"sort\": \"+updatedAt, +createdAt\"}\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
	req.Header.Add("x-fabric-channel-id", "<x-fabric-channel-id>")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Response

#### Success Response (202)

```json
{
  "module": "ORDER",
  "recordFormat": "CSV",
  "version": 2,
  "createdAt": "2022-11-22T10:26:38Z",
  "csvHeadersConfig": "default",
  "exportId": "order_2022-11-25T17-25-38-417225543Z",
  "status": "INITIATED",
  "totalRecordsExported": 20,
  "totalRowsExported": 20,
  "updatedAt": "2022-11-22T10:26:38Z",
  "url": "https://abc.zip"
}
```

#### Error Responses

```json
{
  "errors": [
    {
      "message": "Invalid request",
      "type": "CLIENT_ERROR"
    }
  ],
  "message": "Bad request",
  "type": "CLIENT_ERROR"
}
```

```json
{
  "message": "Unauthorized request",
  "type": "CLIENT_ERROR"
}
```

```json
{
  "message": "Internal server error",
  "type": "SERVER_ERROR"
}
```

### Authorizations
- `Authorization`: Bearer authentication header of the form `Bearer <token>`

### Headers
- `x-fabric-tenant-id`: Required header to identify the tenant making the request.
- `x-fabric-channel-id`: Identifies the sales channel for the API request.

### Body
- `filters`: JSON object to filter records based on attributes. Example:
  ```json
  { "createdAt": "2022-08-01T20:03:28Z" }
  ```
- `module`: The fabric service from which data is exported. Example: `"ORDER"`
- `recordFormat`: Format of the exported records, can be `CSV` or `JSON`.
- `csvHeadersConfig`: Header configuration for CSV export. Example: `"default"`
- `sort`: Property for sorting the data. Example: `"+updatedAt, +createdAt"`.

### Response Structure
- `module`: Exported module (e.g., ORDER)
- `recordFormat`: Format of exported records (CSV or JSON)
- `exportId`: Unique ID for the export request
- `status`: Current status of the export request (e.g., INITIATED)
- `totalRecordsExported`: Number of records exported
- `url`: Download URL for the exported data.
